--Vss_Deli24 IdolA (Hime) lua

--Also handles spawning lida bombs and superlazer

--idolA jumps off chopper at 1 min remaning, yells at 57 seconds remaining
--superlazer is gettable at 48.5 seconds remaining

--wave 1 @ 15 secs:
--MID
--O
--O
--X
--X

--wave 2 @ 75 secs:
--MID
--O
--O
--O
--X

--wave 3 @ 135 secs:
--MID
--X
--O
--O
--O

--wave 4+ @ 195 secs, etc.:
--MID
--O
--O
--O
--O

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir

--senpai calls
freeslot(
"sfx_scall0",
"sfx_scall1",
"sfx_scall2"
)

--senpai general sfx
freeslot(
"sfx_scable",
"sfx_senbye"
)

--senpai mobjs
freeslot(
"MT_SENPAIIDOLA",

"MT_SENPAIPARTICLE"
)

--senpai sprite
freeslot(
"SPR_DESW",
"SPR_DESY",
"SPR_DSP1",
"SPR_DSP2",
"SPR_DESJ",
"SPR_DESR",

"SPR_DESP"
)

--states
freeslot(
"S_SENPAIWAIT",
"S_SENPAIYELL",
"S_SENPAIYELLLOOP",
"S_SENPAIYELLREADY",
"S_SENPAIYELLREADYLOOP",
"S_SENPAISPIN",
"S_SENPAIPREPARE",
"S_SENPAIPREPARELOOP",
"S_SENPAIFALL",
"S_SENPAIFALLLOOKL",
"S_SENPAIFALLLOOKR",

"S_SENPAIPARTICLEA",
"S_SENPAIPARTICLEB",
"S_SENPAIPARTICLESTRING"
)

sfxinfo[sfx_scall0] = {
        singular = false,
        priority = 64,
        flags = SF_X2AWAYSOUND|SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_NOMULTIPLESOUND
}

sfxinfo[sfx_scall1] = {
        singular = false,
        priority = 64,
        flags = SF_X2AWAYSOUND|SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_NOMULTIPLESOUND
}

sfxinfo[sfx_scall2] = {
        singular = false,
        priority = 64,
        flags = SF_X2AWAYSOUND|SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_NOMULTIPLESOUND
}

sfxinfo[sfx_scable] = {
        singular = false,
        priority = 64,
        flags = SF_X2AWAYSOUND|SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_NOMULTIPLESOUND
}

mobjinfo[MT_SENPAIIDOLA] = {
	doomednum = -1,
    spawnstate = S_SENPAIFALL,
    spawnhealth = 9000,
	--deathstate = S_SENPAIWAIT,
    radius = 32*FRACUNIT,
    height = 128*FRACUNIT,
    flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SPECIAL
}

mobjinfo[MT_SENPAIPARTICLE] = {
	doomednum = -1,
    spawnstate = S_SENPAIPARTICLESTRING,
    spawnhealth = 9000,
    radius = 2*FRACUNIT,
    height = 2*FRACUNIT,
    flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

states[S_SENPAIWAIT] = {
        sprite = SPR_DESW,
        frame = FF_ANIMATE|A,
        tics = 7*4,
		nextstate = S_SENPAIWAIT,
		var1 = 7,
		var2 = 4
}

states[S_SENPAIYELLREADY] = {
        sprite = SPR_DESR,
        frame = FF_ANIMATE|A,
        tics = 17*2,
		nextstate = S_SENPAIYELLREADYLOOP,
		var1 = 17,
		var2 = 2
}

states[S_SENPAIYELLREADYLOOP] = {
        sprite = SPR_DESR,
        frame = R,
        tics = 1,
		nextstate = S_SENPAIYELLREADYLOOP,
}


states[S_SENPAIPREPARE] = {
        sprite = SPR_DSP1,
        frame = FF_ANIMATE|A,
        tics = 3*3,
		nextstate = S_SENPAIPREPARELOOP,
		var1 = 3,
		var2 = 3
}

states[S_SENPAIPREPARELOOP] = {
        sprite = SPR_DSP2,
        frame = FF_ANIMATE|A,
        tics = 7*3,
		nextstate = S_SENPAIPREPARELOOP,
		var1 = 7,
		var2 = 3
}

states[S_SENPAIYELL] = {
        sprite = SPR_DESY,
        frame = A,
        tics = 8,
		nextstate = S_SENPAIYELLLOOP,
}

states[S_SENPAIYELLLOOP] = {
        sprite = SPR_DESY,
        frame = B,
        tics = 1,
		nextstate = S_SENPAIYELLLOOP,
}

states[S_SENPAISPIN] = {
        sprite = SPR_DESY,
        frame = C,
        tics = 1,
		nextstate = S_SENPAISPIN,
}

states[S_SENPAIFALL] = {
        sprite = SPR_DESJ,
        frame = A,
        tics = 1,
		nextstate = S_SENPAIFALL,
}

states[S_SENPAIFALLLOOKL] = {
        sprite = SPR_DESJ,
        frame = B,
        tics = 1,
		nextstate = S_SENPAIFALLLOOKL,
}

states[S_SENPAIFALLLOOKR] = {
        sprite = SPR_DESJ,
        frame = C,
        tics = 1,
		nextstate = S_SENPAIFALLLOOKR,
}


states[S_SENPAIPARTICLEA] = {
        sprite = SPR_DESP,
        frame = A,
        tics = -1,
		nextstate = S_SENPAIPARTICLEA
}

states[S_SENPAIPARTICLEB] = {
        sprite = SPR_DESP,
        frame = B,
        tics = -1,
		nextstate = S_SENPAIPARTICLEB
}

states[S_SENPAIPARTICLESTRING] = {
        sprite = SPR_DESP,
        frame = C,
        tics = 1,
		nextstate = S_SENPAIPARTICLESTRING,
		action = A_GhostMe
}

local function AT_flerp(num, denum, minimum, maximum)
	local p = FixedDiv(num, denum)
	local a = FixedMul((maximum - minimum), p)
	local v = minimum + a
	return v
end

local function AT_inback(num, denum, minimum, maximum)
	local p = FixedDiv(num, denum)
	local c1 = 65*FRACUNIT/10
	local c2 = c1 + FRACUNIT
	local x = FixedMul(FixedMul(FixedMul(p, p), p), c2) - FixedMul(FixedMul(p, p), c1)
	local a = FixedMul((maximum - minimum), x)
	local v = minimum + a
	return v
end

local function AT_outquad(num, denum, minimum, maximum)
	local p = FixedDiv(num, denum)
	local x = FRACUNIT - FixedMul(FRACUNIT - p, FRACUNIT - p)
	local a = FixedMul((maximum - minimum), x)
	local v = minimum + a
	return v
end

local function spawnsenpai()
	local hime = P_SpawnMobj(0, 0, 1280*FRACUNIT, MT_SENPAIIDOLA)
	server.deli_senpaiidol = hime
	hime.ready = false
	hime.unclaimed = true
	hime.directed = "jump"
	hime.claimer = false
	hime.scale = $+FRACUNIT/2
	hime.angle = 0
	hime.aoldangle = 90*ANG1
	hime.frompos = {x = -48*FRACUNIT, y = 0, z = 1280*FRACUNIT}
	hime.topos = {x = -48*FRACUNIT, y = 0, z = 416*FRACUNIT}
	hime.topostics = 10*TICRATE + 17
	hime.toposticsD = 0
	hime.toposmode = 0
	hime.senpai = nil
	hime.state = S_SENPAIFALL
end

local function respawnsenpailost(sx, sy, sz, ang)
	local hime = P_SpawnMobj(sx, sy, sz, MT_SENPAIIDOLA)
	server.deli_senpaiidol = hime
	hime.ready = false
	hime.unclaimed = true
	hime.directed = "return"
	hime.state = S_SENPAIFALL
	hime.claimer = false
	hime.scale = $+FRACUNIT/2
	hime.angle = ang
	hime.aoldangle = ang
	hime.frompos = {x = sx, y = sy, z = sz}
	hime.topos = {x = -48*FRACUNIT, y = 0, z = 416*FRACUNIT}
	hime.topostics = 5*TICRATE
	hime.toposticsD = 0
	hime.toposmode = 0
	hime.senpai = nil
end

local function checkbombcol(mo)
	local dist -- horizontal range
	
	dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
	
	if (dist > FixedMul(mo.radius + mo.target.radius, mo.scale)) then return false end

	if (dist > FixedMul(mo.radius + mo.target.radius, mo.scale)) and mo.z+mo.height+mo.target.height >= mo.target.z then
		return true
		
	else
		return false
	end
end

rawset(_G, "deli_senpaiidol", 0)

addHook("NetVars", function(net)
	server.deli_senpaiidol = net(server.deli_senpaiidol)
end)

addHook("ThinkFrame", do
	if gamemap == 295 then
		if server.deli_timelimit then
			if leveltime == ((6*TICRATE + (3*TICRATE/4)) + (server.deli_timelimit*60*TICRATE - 60*TICRATE)) and server.deli_timelimit > 1 then
				spawnsenpai()
			end
			if leveltime == ((6*TICRATE + (3*TICRATE/4)) + (server.deli_timelimit*60*TICRATE - 60*TICRATE + 3*TICRATE)) and server.deli_timelimit > 1 then
				local s = P_RandomRange(0, 2)
				if s == 0 then
					S_StartSound(server.deli_senpaiidol, sfx_scall0)
				elseif s == 1 then
					S_StartSound(server.deli_senpaiidol, sfx_scall1)
				elseif s == 2 then
					S_StartSound(server.deli_senpaiidol, sfx_scall2)
				end
			end
		end
		--handle lida bomb respawns
		if leveltime > (6*TICRATE + (3*TICRATE/4)) then
			if leveltime - (6*TICRATE + (3*TICRATE/4)) == 15*TICRATE then
			
				deli_createlidabomb(-1152*FRACUNIT, 720*FRACUNIT, 312*FRACUNIT, SKINCOLOR_SILVER, 0, 1)
				deli_createlidabomb(0, 1440*FRACUNIT, 256*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 2)
				
				deli_createlidabomb(1152*FRACUNIT, -720*FRACUNIT, 312*FRACUNIT, SKINCOLOR_BRONZE, 180*ANG1, 5)
				deli_createlidabomb(0, -1440*FRACUNIT, 256*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 6)
				
			elseif leveltime - (6*TICRATE + (3*TICRATE/4)) == 75*TICRATE then
			
				deli_createlidabomb(-1152*FRACUNIT, 720*FRACUNIT, 312*FRACUNIT, SKINCOLOR_SILVER, 0, 01)
				deli_createlidabomb(0, 1440*FRACUNIT, 256*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 2)
				deli_createlidabomb(0, 2784*FRACUNIT, 128*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 3)
				
				deli_createlidabomb(1152*FRACUNIT, -720*FRACUNIT, 312*FRACUNIT, SKINCOLOR_BRONZE, 180*ANG1, 5)
				deli_createlidabomb(0, -1440*FRACUNIT, 256*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 6)
				deli_createlidabomb(0, -2784*FRACUNIT, 128*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 7)
				
			elseif leveltime - (6*TICRATE + (3*TICRATE/4)) == 135*TICRATE then
				
				deli_createlidabomb(0, 1440*FRACUNIT, 256*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 2)
				deli_createlidabomb(0, 2784*FRACUNIT, 128*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 3)
				deli_createlidabomb(0, 3888*FRACUNIT, 0*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 4)
				
				deli_createlidabomb(0, -1440*FRACUNIT, 256*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 6)
				deli_createlidabomb(0, -2784*FRACUNIT, 128*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 7)
				deli_createlidabomb(0, -3888*FRACUNIT, 0*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 8)
			elseif leveltime - (6*TICRATE + (3*TICRATE/4)) == 135*TICRATE + 60*TICRATE or leveltime - (6*TICRATE + (3*TICRATE/4)) == 135*TICRATE + 120*TICRATE then
			
				deli_createlidabomb(-1152*FRACUNIT, 720*FRACUNIT, 312*FRACUNIT, SKINCOLOR_SILVER, 0, 1)
				deli_createlidabomb(0, 1440*FRACUNIT, 256*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 2)
				deli_createlidabomb(0, 2784*FRACUNIT, 128*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 3)
				deli_createlidabomb(0, 3888*FRACUNIT, 0*FRACUNIT, SKINCOLOR_SILVER, 270*ANG1, 4)
				
				deli_createlidabomb(1152*FRACUNIT, -720*FRACUNIT, 312*FRACUNIT, SKINCOLOR_BRONZE, 180*ANG1, 5)
				deli_createlidabomb(0, -1440*FRACUNIT, 256*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 6)
				deli_createlidabomb(0, -2784*FRACUNIT, 128*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 7)
				deli_createlidabomb(0, -3888*FRACUNIT, 0*FRACUNIT, SKINCOLOR_BRONZE, 90*ANG1, 8)
				
			end
		end
	end
end)



addHook("MobjThinker", function(hime)
	
	--code that handles hime's state machine
	if hime.ready then
		if leveltime % 4 ~= 0 then
			local particle = P_SpawnMobj(hime.x+P_RandomRange(-8, 8)*hime.scale, hime.y+P_RandomRange(-8, 8)*hime.scale, hime.z+P_RandomRange(45, 50)*hime.scale, MT_SENPAIPARTICLE)
			particle.ltics = 0
			particle.color = SKINCOLOR_PURPLE
			particle.scale = FRACUNIT/2
			if P_RandomChance(FRACUNIT/2) then
				particle.state = S_SENPAIPARTICLEA
			else
				particle.state = S_SENPAIPARTICLEB
			end
			P_SetObjectMomZ(particle, P_RandomRange(2, 6)*particle.scale)
		end
		if leveltime % 4 == 0 then
			local particle = P_SpawnMobj(hime.x+P_RandomRange(-8, 8)*hime.scale, hime.y+P_RandomRange(-8, 8)*hime.scale, hime.z+P_RandomRange(5, 45)*hime.scale, MT_SENPAIPARTICLE)
			particle.ltics = 0
			particle.color = SKINCOLOR_PURPLE
			particle.state = S_SENPAIPARTICLESTRING
			particle.flipvelv = P_RandomChance(FRACUNIT/2)
			particle.flipvelh = P_RandomChance(FRACUNIT/2)
			particle.angle = ANG1*P_RandomRange(0, 360)
		end
	end
	if hime.claimer 
		if hime.directed == "wait" then		--long ass if/else block jesus fucking christ I feel like yandev rn
			local sx = hime.claimer.mo.x + FixedMul(FixedMul(-32*FRACUNIT, cos(hime.claimer.mo.angle + 90*ANG1)), mapobjectscale)
			local sy = hime.claimer.mo.y + FixedMul(FixedMul(-32*FRACUNIT, sin(hime.claimer.mo.angle + 90*ANG1)), mapobjectscale)
			local sz = hime.claimer.mo.z + 24*FRACUNIT
			hime.angle = hime.claimer.mo.angle
			P_TeleportMove(hime, sx, sy, sz)
			if hime.claimer.hassuperlazer == false then
				if hime.claimer.senpai ~= nil and hime.claimer.senpai.used then
					hime.state = S_SENPAIYELLREADY
					hime.frompos = {x = hime.x, y = hime.y, z = hime.z}
					hime.topos = {x = hime.claimer.mo.x, y = hime.claimer.mo.y, z = hime.claimer.mo.z}
					hime.toposmode = 0
					hime.directed = "yellready"
					hime.aoldangle = hime.angle
					hime.senpai = hime.claimer.senpai
				else
					respawnsenpailost(hime.x, hime.y, hime.z, 0)
					hime.state = S_NULL
					return
				end
			end
		elseif hime.directed == "yellready" then
			if hime.state == S_SENPAIYELLREADYLOOP then
				hime.directed = "yellreadyloop"
				hime.topostics = 12
				hime.toposticsD = 0
				hime.toposmode = 0
			end
		elseif hime.directed == "yellreadyloop" then
			hime.angle = FixedAngle(AT_flerp(hime.toposticsD, hime.topostics, AngleFixed(hime.aoldangle), AngleFixed(hime.aoldangle) + 360*FRACUNIT))
			if hime.toposticsD == hime.topostics then
				hime.state = S_SENPAIYELL
				hime.directed = "yell"
				hime.angle = hime.aoldangle
				hime.frompos = hime.topos
				hime.topostics = 0
				hime.toposticsD = 0
				hime.toposmode = 0
			end
		elseif hime.directed == "yell" then
			if hime.state == S_SENPAIYELLLOOP then
				hime.directed = "yellloop"
			end
		elseif hime.directed == "yellloop" then
			hime.z = hime.topos.z - (sin((leveltime+P_RandomRange(-90, 90))*ANG60))
			if (not hime.senpai.valid) then
				
				
				hime.toexit = 17
				hime.state = S_SENPAISPIN
				hime.directed = "exit"
			end
		elseif hime.directed == "exit" then
			if hime.toexit ~= 0 then
				hime.momz = $-FRACUNIT/45
			elseif hime.toexit == 0 then
				if hime.momz <= 14*FRACUNIT then
				local glow = P_SpawnMobj(hime.x, hime.y, hime.z, MT_BOMBLIDAGLOW)
				glow.scale = FRACUNIT/2
				glow.destscale = FRACUNIT*2
				glow.color = SKINCOLOR_PURPLE
				S_StartSound(hime, sfx_senbye)
				local i = 0
				while i <= 40 do
					local particle = P_SpawnMobj(hime.x+P_RandomRange(-8, 8)*hime.scale, hime.y+P_RandomRange(-8, 8)*hime.scale, hime.z+P_RandomRange(5, 45)*hime.scale, MT_SENPAIPARTICLE)
					particle.ltics = 0
					particle.color = SKINCOLOR_PURPLE
					particle.state = S_SENPAIPARTICLESTRING
					particle.flipvelv = P_RandomChance(FRACUNIT/2)
					particle.flipvelh = P_RandomChance(FRACUNIT/2)
					particle.moreltics = true
					particle.angle = ANG1*P_RandomRange(0, 360)
					i = $+1
				end
				end
				
				local particle = P_SpawnMobj(hime.x+P_RandomRange(-2, 2)*hime.scale, hime.y+P_RandomRange(-2, 2)*hime.scale, hime.z+P_RandomRange(45, 50)*hime.scale, MT_SENPAIPARTICLE)
				particle.ltics = 0
				particle.color = SKINCOLOR_PURPLE
				particle.scale = FRACUNIT/2
				if P_RandomChance(FRACUNIT/2) then
					particle.state = S_SENPAIPARTICLEA
				else
					particle.state = S_SENPAIPARTICLEB
				end
				P_SetObjectMomZ(particle, P_RandomRange(2, 6)*particle.scale)
				hime.angle = $ + 30*ANG1
				hime.momz = $+16*FRACUNIT
				if hime.momz >= 36*FRACUNIT then
					hime.angle = $ + 15*ANG1
				end
				if hime.z >= 600*FRACUNIT then
					
					hime.ready = false
					hime.directed = "xexit"
					hime.state = S_INVISIBLE
				end
			end
		elseif hime.directed == "xexit" then
			
		end
	else
		if hime.directed == "jump" then
			if hime.toposticsD == hime.topostics then
				hime.state = S_SENPAIPREPARE
				hime.directed = "prepare1"
			end
		elseif hime.directed == "prepare1" then
			if hime.state == S_SENPAIPREPARELOOP then
				S_StartSound(hime, sfx_scable)
				hime.directed = "prepare2"
				hime.ready = true
				hime.flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SPECIAL
			end
		elseif hime.directed == "prepare2" then
			
		elseif hime.directed == "return" then
			if hime.toposticsD == hime.topostics then
				hime.state = S_SENPAIPREPARE
				hime.directed = "prepare1"
			end
		end
	end
	if hime.toposticsD < hime.topostics then
		local sx, sy, sz
		if hime.toposmode == 0 then
			sx = AT_outquad(hime.toposticsD, hime.topostics, hime.frompos.x, hime.topos.x)
			sy = AT_outquad(hime.toposticsD, hime.topostics, hime.frompos.y, hime.topos.y)
			sz = AT_outquad(hime.toposticsD, hime.topostics, hime.frompos.z, hime.topos.z)
		elseif hime.toposmode == 2 then
			sx = AT_flerp(hime.toposticsD, hime.topostics, hime.frompos.x, hime.topos.x)
			sy = AT_flerp(hime.toposticsD, hime.topostics, hime.frompos.y, hime.topos.y)
			sz = AT_flerp(hime.toposticsD, hime.topostics, hime.frompos.z, hime.topos.z)
		end
		P_TeleportMove(hime, sx, sy, sz)
		hime.toposticsD = $+1
	end
	if hime.toexit then hime.toexit = $-1 end
end, MT_SENPAIIDOLA)

addHook("PlayerQuit", function(p)
	if gamemap ~= 295 then return end
	if not (server and server.deli_senpaiidol) then return end
	if server.deli_senpaiidol and server.deli_senpaiidol.valid then
		if p == server.deli_senpaiidol.claimer then
			respawnsenpailost(server.deli_senpaiidol.x, server.deli_senpaiidol.y, server.deli_senpaiidol.z, 0)
			server.deli_senpaiidol.state = S_NULL
		end
	end
end)

addHook("TouchSpecial", function(hime, s)
	if s.type == MT_PLAYER and hime.unclaimed and hime.ready then
		local p = s.player
		if p.kartstuff[k_bumper] then
			deli_createsuperlazer(p)
			hime.unclaimed = false
			hime.claimer = p
			hime.directed = "wait"
			hime.state = S_SENPAIWAIT
		end
	end
	return true
end, MT_SENPAIIDOLA)

addHook("MobjThinker", function(p)
	p.ltics = $+1
	if p.state == S_SENPAIPARTICLESTRING then
		if p.flipvelh then
			p.angle = $-P_RandomRange(3, 5)*ANG1
		else
			p.angle = $+P_RandomRange(3, 5)*ANG1
		end
		if p.moreltics and abs(p.momz) <= FRACUNIT and p.ltics <= 17 then
			if p.flipvelv then
				P_SetObjectMomZ(p, p.momz - P_RandomRange(p.scale/12, p.scale/10))
			else
				P_SetObjectMomZ(p, p.momz + P_RandomRange(p.scale/12, p.scale/10))
			end
		elseif (not p.moreltics) then
			if p.flipvelv then
				P_SetObjectMomZ(p, p.momz - P_RandomRange(p.scale/4, p.scale/2))
			else
				P_SetObjectMomZ(p, p.momz + P_RandomRange(p.scale/4, p.scale/2))
			end
		end
		if p.ltics <= 17 then
			P_InstaThrust(p, p.angle, 4*FRACUNIT)
		end
		if p.ltics > 17 and p.ltics < TICRATE then
			P_InstaThrust(p, p.angle, 3*FRACUNIT)
		end
		if p.ltics == TICRATE then
			P_InstaThrust(p, p.angle, 2*FRACUNIT)
		end
	else
		p.scale = $-FRACUNIT/48
	end
	if p.moreltics then
		if p.ltics >= TICRATE*3 then
			P_RemoveMobj(p)
		end
	else
		if p.ltics >= 17 then
			P_RemoveMobj(p)
		end
	end
end, MT_SENPAIPARTICLE)

addHook("MobjThinker", function(bomb)		--this is lida bomb code, why did I put this here?
	if bomb.toposticsD <= bomb.topostics then
		local sx, sy, sz
		sx = AT_flerp(bomb.toposticsD, bomb.topostics, bomb.frompos.x, bomb.topos.x)
		sy = AT_flerp(bomb.toposticsD, bomb.topostics, bomb.frompos.y, bomb.topos.y)
		sz = AT_inback(bomb.toposticsD, bomb.topostics, bomb.frompos.z, bomb.topos.z)
		P_TeleportMove(bomb, sx, sy, sz)
		bomb.toposticsD = $+1
	else
		P_TeleportMove(bomb, bomb.topos.x, bomb.topos.y, bomb.topos.z)
		for p in players.iterate do
			if p.mo and p.mo.valid then
				bomb.target = p.mo
				if checkbombcol(bomb) then
					local sx = p.mo.x + FixedMul(FixedMul(-(bomb.radius + p.mo.radius), cos(R_PointToAngle2(p.mo.x, p.mo.y, bomb.x, bomb.y))), 4*FRACUNIT/3)
					local sy = p.mo.y + FixedMul(FixedMul(-(bomb.radius + p.mo.radius), sin(R_PointToAngle2(p.mo.x, p.mo.y, bomb.x, bomb.y))), 4*FRACUNIT/3)
					P_TeleportMove(p.mo, sx, sy, p.mo.z)
					P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_BUMP)
					P_InstaThrust(p.mo, R_PointToAngle2(p.mo.x, p.mo.y, bomb.x, bomb.y), -(bomb.radius + p.mo.radius)*3)
				end
			end
		end
	end
	if bomb.toposticsD == bomb.topostics then
		bomb.topostics = 0
		S_StartSound(bomb, sfx_libola)
		
	end
	if leveltime == bomb.spawntime + 2*TICRATE then
		S_StartSound(bomb, sfx_libfly)
	end
	if leveltime == bomb.spawntime + 3*TICRATE + 17 then
		S_StartSound(bomb, sfx_liboon)
	end
end, MT_BOMBLIDA)


hud.add(function(v, p, c)
	if gamemap == 295 and server.deli_timelimit then
		local STARTTIME = ((6*TICRATE + (3*TICRATE/4)) + (server.deli_timelimit*60*TICRATE - 60*TICRATE + 3*TICRATE))
		local ENDTIME = ((6*TICRATE + (3*TICRATE/4)) + (server.deli_timelimit*60*TICRATE - 60*TICRATE + 6*TICRATE))
		local targettrans = CV_FindVar("translucenthud").value
		if leveltime >= STARTTIME and leveltime <= ENDTIME and server.deli_timelimit > 1 then
			local text = v.cachePatch("IDOLCOME")
			local t = leveltime - STARTTIME
			if t <= 5 then
				local s = AT_outquad(t, 5, FRACUNIT*2, 5*FRACUNIT/6)
				--local sx = AT_outquad(t, 8, FRACUNIT*4, FRACUNIT)
				--local sy = AT_outquad(t, 8, 4*FRACUNIT/3, FRACUNIT)
				local trans = FixedInt(AT_flerp(t, 5, targettrans*FRACUNIT, 0))
				v.drawScaled(320*FRACUNIT/2 - FixedMul(148*FRACUNIT + FRACUNIT/2, s), 200*FRACUNIT/2 - FixedMul(8*FRACUNIT, s), s, text, trans<<V_ALPHASHIFT)
				--v.drawStretched(320*FRACUNIT/2 - FixedMul(148*FRACUNIT + FRACUNIT/2, s), 200*FRACUNIT/2 - FixedMul(8*FRACUNIT, s), sx, sy, text, trans<<V_ALPHASHIFT)		--f this shit doesn't exist
			elseif t - 2*TICRATE - (TICRATE-8) >= 0 then
				local s = AT_outquad(t - 2*TICRATE - (TICRATE-8), 8, 5*FRACUNIT/6, FRACUNIT*3)
				local trans = FixedInt(AT_flerp(t - 2*TICRATE - (TICRATE-8), 8, 0, targettrans*FRACUNIT))
				v.drawScaled(320*FRACUNIT/2 - FixedMul(148*FRACUNIT + FRACUNIT/2, s), 200*FRACUNIT/2 - FixedMul(8*FRACUNIT, s), s, text, trans<<V_ALPHASHIFT)
			else
				v.drawScaled(320*FRACUNIT/2 - FixedMul(148*FRACUNIT + FRACUNIT/2, 5*FRACUNIT/6), 200*FRACUNIT/2 - FixedMul(8*FRACUNIT, 5*FRACUNIT/6), 5*FRACUNIT/6, text, V_HUDTRANS)
			end
		end
	end
end, "game") --I hate this